VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4275
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6555
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   285
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   437
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.VScrollBar VScroll1 
      Height          =   1215
      Left            =   1680
      TabIndex        =   2
      Top             =   240
      Width           =   255
   End
   Begin VB.PictureBox Picture1 
      Height          =   495
      Left            =   240
      ScaleHeight     =   435
      ScaleWidth      =   1155
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function PaintRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

Private Const RGN_DIFF As Long = 4

Private SW As Single, SH As Single

Private Sub Form_Load()
  ' Einstellungen
  
  With Me
    .ScaleMode = vbPixels
    .Caption = "Bestehende Region in beliebigem Winkel drehen"
    .WindowState = vbMaximized
  End With
  
  With Picture1
    .ScaleMode = vbPixels
    .Move 4, 4, 500, 500
    SW = .ScaleWidth
    SH = .ScaleHeight
    .AutoRedraw = True
    .FillColor = RGB(255, 200, 0)
    .FillStyle = vbFSSolid
  End With
  
  With VScroll1
    .Move 4 + Picture1.Width, 4, 24, Picture1.Height
    .TabStop = False
    .Min = 0
    .Max = 360
    .LargeChange = 15
    .Value = 180
  End With
  
  With Label1
    .Left = VScroll1.Left + VScroll1.Width + 20
    .FontSize = 14
    .FontBold = True
    .AutoSize = True
  End With
  
  Call VScroll1_Scroll

End Sub

Private Sub VScroll1_Change()
  ' Event weiterreichen
  
  Call VScroll1_Scroll

End Sub

Private Sub VScroll1_Scroll()
  ' Region erzeugen und drehen
  
  Dim Rgn1 As Long, Rgn2 As Long, Winkel As Single
  Dim XM As Single, YM As Single
  Dim Rad1 As Single, Rad2 As Single
  
  With VScroll1
    Winkel = 360 - .Value
    Label1.Top = .Top + 16 + (.Height - 51) * .Value / .Max
  End With
  Label1.Caption = Winkel & " "

  ' Grafik lschen
  Picture1.Line (0, 0)-(SW, SH), RGB(0, 0, 128), BF
  ' Region erstellen
  XM = SW / 2
  YM = SH / 2
  Rad1 = 180
  Rad2 = 75
  Rgn1 = CreateEllipticRgn(XM - Rad1, YM - Rad2, _
    XM + Rad1, YM + Rad2)
  Rgn2 = CreateRectRgn(XM + 90, YM - 25, XM + 120, YM + 25)
  Call CombineRgn(Rgn1, Rgn1, Rgn2, RGN_DIFF)
  ' Region drehen
  Call RotateRegion(Rgn1, Winkel)
  ' Region zeichnen
  Call PaintRgn(Picture1.hdc, Rgn1)
  ' Speicher aufrumen
  Call DeleteObject(Rgn1)
  Call DeleteObject(Rgn2)

End Sub
